//+------------------------------------------------------------------+
//|                                                       Trader.mqh |
//|                        Copyright 2013, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+

#include "Money.mqh"
#include "Positions.mqh"
#include "WizGator.mqh"

input int   SL;
input int   TP;
input double TRAILING;

input int   OPEN_LONG=100;
input int   CUT_LONG=50;
input int   CUT_SHORT=-50;
input int   OPEN_SHORT=-100;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
class Trader
  {
public:
                     Trader(string symbol);
                    ~Trader(void) {};

   bool              init();
   void              decision();
   bool              deInit();
private:
   string            _symbol;
   Money             _money;
   Positions         _positions;
   WizGator          _wizGator;
  };
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
Trader::Trader(string symbol) : _money(symbol),_positions(symbol),_wizGator(symbol,PERIOD_H1)
  {
   _symbol=symbol;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool  Trader::init()
  {
   return _wizGator.init();
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void  Trader::decision(void)
  {
   double result;

   _money.refresh();
   result=_wizGator.refresh();

   if(_positions.checkActiveOrder()==true)
     {
      if((_positions.getActiveOrderType()==ORDER_TYPE_BUY) && result<=CUT_LONG)
         _positions.closePosition();
      if((_positions.getActiveOrderType()==ORDER_TYPE_SELL) && result>=CUT_SHORT)
         _positions.closePosition();
     }
   else
     {
      if(result>=OPEN_LONG)
         _positions.openLongPosition(_money.getVolume(SL));
      else if(result<=OPEN_SHORT)
         _positions.openShortPosition(_money.getVolume(SL));
      else
         return;
      _positions.setStopLossByPoint(SL);
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool   Trader::deInit(void)
  {
   return _wizGator.deInit();
  }
//+------------------------------------------------------------------+
